﻿@page "/users/create"
@page "/users/{Id:int}/edit"
@using Syncfusion.Blazor.DropDowns

<PageTitle>JWobot Admin | User Form</PageTitle>
<div class="d-sm-flex align-items-center justify-content-between mb-4">
    <h1 class="h3 mb-0 text-gray-800">User Form</h1>
</div>


<div class="card shadow mb-4">
    <div class="card-body">
        <EditForm Model="@uModel" OnValidSubmit="@HandleValidSubmit" OnInvalidSubmit="@HandleInvalidSubmit">
            <DataAnnotationsValidator />
            <ValidationSummary />
            <div class="row">
                <div class="col-md-3 mb-3">
                    <div class="form-group">
                        <label>First Name</label>
                        <InputText id="firstName" @bind-Value="uModel.FirstName" class="form-control" />
                    </div>
                </div>
                <div class="col-md-3 mb-3">
                    <div class="form-group">
                        <label>Middle Name</label>
                        <InputText id="middleName" @bind-Value="uModel.MiddleName" class="form-control" />
                    </div>
                </div>
                <div class="col-md-3 mb-3">
                    <div class="form-group">
                        <label>Last Name</label>
                        <InputText id="lastName" @bind-Value="uModel.LastName" class="form-control" />
                    </div>
                </div>
                <div class="col-md-3 mb-3">
                    <div class="form-group">
                        <label>Email Address</label>
                        <InputText id="email" @bind-Value="uModel.Email" class="form-control" />
                    </div>
                </div>
                @if (!uModel.IsAdmin)
                {
                    <div class="col-md-12 mb-3">
                        <div class="form-group">
                            <label>ChatBots</label>
                            <SfMultiSelect TValue="int?[]" TItem="ChatBot" Placeholder="Select chatbots" DataSource="@chatbots" @bind-Value="@uModel.ChatBotIds">
                                <MultiSelectFieldSettings Text="Name" Value="Id"></MultiSelectFieldSettings>
                            </SfMultiSelect>
                        </div>
                    </div>
                }
                <div class="col-md-12 mb-3">
                    <InputCheckbox @bind-Value="uModel.IsAdmin"></InputCheckbox> Admin
                </div>
                <div class="col-md-12 mb-3">
                    <InputCheckbox @bind-Value="uModel.IsActive"></InputCheckbox> Active
                </div>
            </div>
            <div class="form-group mt-3">
                @if (Id.HasValue)
                {
                    <button type="button" class="btn btn-danger" @onclick="Delete">Delete</button>
                }
                <button type="submit" class="btn btn-primary float-right">Save</button>
            </div>
        </EditForm>
    </div>
</div>

@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationStateTask { get; set; }
    private string email;

    [Parameter]
    public int? Id { get; set; }
    private bool isSaving = false;

    private UserModel uModel = new UserModel();
    public string pageTitle = "Create User";
    private List<ChatBot> chatbots;

    protected async override Task OnInitializedAsync()
    {
        await JS.ShowLoader();
        var claimsPrincipal = (await authenticationStateTask).User;
        email = ((CustomAuthenticationStateProvider)AuthenticationStateProvider).GetCurrentUserEmail(claimsPrincipal);

        if (Id.HasValue)
        {
            pageTitle = "Update User";
            uModel = Mapper.Map<UserModel>(UserService.GetById(Id.Value));
        }
        chatbots = ChatBotService.GetAll().ToList();
        await JS.HideLoader();

    }

    protected async Task HandleInvalidSubmit()
    {
        await JS.ShowError(pageTitle, "Please complete all requried fields");
    }

    private async Task HandleValidSubmit()
    {
        if (!isSaving)
        {
            isSaving = true;
            await JS.ShowLoader();
            try
            {
                var u = Mapper.Map<User>(uModel);
                var action = "created";
                if (Id.HasValue)
                {
                    action = "updated";
                    u.Id = Id.Value;
                    u.ModifiedBy = email;
                    await UserService.Update(u);
                }
                else
                {
                    u.CreatedBy = email;
                    await UserService.Create(u);
                }
                await JS.ShowSuccess(pageTitle, $"User successfully {action}");
                Navigation.NavigateTo("/users");
            }
            catch (Exception ex)
            {
                await JS.ShowError(pageTitle, ex.Message.ToString());
            }

            await JS.HideLoader();
            isSaving = false;
        }
    }

    private async Task Delete()
    {
        await UserService.Delete(Id.Value);
        await JS.ShowSuccess(pageTitle, $"User successfully deleted");
        Navigation.NavigateTo("users");
    }
}
